diff -urp v2.6.33/linux/Documentation/networking/ip-sysctl.txt linux/Documentation/networking/ip-sysctl.txt
--- v2.6.33/linux/Documentation/networking/ip-sysctl.txt	2010-02-25 09:01:26.000000000 +0200
+++ linux/Documentation/networking/ip-sysctl.txt	2010-02-25 10:50:30.000000000 +0200
@@ -669,6 +669,17 @@ accept_redirects - BOOLEAN
 forwarding - BOOLEAN
 	Enable IP forwarding on this interface.
 
+forward_shared - BOOLEAN
+	Integer value determines if a source validation should allow
+	forwarding of packets with local source address. 1 means yes,
+	0 means no. By default the flag is disabled and such packets
+	are not forwarded.
+ 
+	If you enable this flag on internal network, the router will forward
+	packets from internal hosts with shared IP addresses no matter how
+	the rp_filter is set. This flag is activated only if it is
+	enabled both in specific device section and in "all" section.
+
 mc_forwarding - BOOLEAN
 	Do multicast routing. The kernel needs to be compiled with CONFIG_MROUTE
 	and a multicast routing daemon is required.
diff -urp v2.6.33/linux/include/linux/inetdevice.h linux/include/linux/inetdevice.h
--- v2.6.33/linux/include/linux/inetdevice.h	2010-02-25 09:01:36.000000000 +0200
+++ linux/include/linux/inetdevice.h	2010-02-25 10:51:41.000000000 +0200
@@ -109,6 +109,7 @@ static inline void ipv4_devconf_setall(s
 #define IN_DEV_ARP_ANNOUNCE(in_dev)	IN_DEV_MAXCONF((in_dev), ARP_ANNOUNCE)
 #define IN_DEV_ARP_IGNORE(in_dev)	IN_DEV_MAXCONF((in_dev), ARP_IGNORE)
 #define IN_DEV_ARP_NOTIFY(in_dev)	IN_DEV_MAXCONF((in_dev), ARP_NOTIFY)
+#define IN_DEV_FORWARD_SHARED(in_dev)	IN_DEV_ANDCONF((in_dev), FORWARD_SHARED)
 
 struct in_ifaddr {
 	struct in_ifaddr	*ifa_next;
diff -urp v2.6.33/linux/include/linux/sysctl.h linux/include/linux/sysctl.h
--- v2.6.33/linux/include/linux/sysctl.h	2010-02-25 09:01:36.000000000 +0200
+++ linux/include/linux/sysctl.h	2010-02-25 10:52:10.000000000 +0200
@@ -483,6 +483,7 @@ enum
 	NET_IPV4_CONF_ARP_NOTIFY=22,
 	NET_IPV4_CONF_ACCEPT_LOCAL=23,
 	NET_IPV4_CONF_SRC_VMARK=24,
+	NET_IPV4_CONF_FORWARD_SHARED=25,
 	__NET_IPV4_CONF_MAX
 };
 
diff -urp v2.6.33/linux/include/net/ip_fib.h linux/include/net/ip_fib.h
--- v2.6.33/linux/include/net/ip_fib.h	2010-02-25 09:01:36.000000000 +0200
+++ linux/include/net/ip_fib.h	2010-02-25 10:50:30.000000000 +0200
@@ -214,7 +214,7 @@ extern const struct nla_policy rtm_ipv4_
 extern void		ip_fib_init(void);
 extern int fib_validate_source(__be32 src, __be32 dst, u8 tos, int oif,
 			       struct net_device *dev, __be32 *spec_dst,
-			       u32 *itag, u32 mark);
+			       u32 *itag, u32 mark, int our);
 extern void fib_select_default(struct net *net, const struct flowi *flp,
 			       struct fib_result *res);
 
diff -urp v2.6.33/linux/kernel/sysctl_binary.c linux/kernel/sysctl_binary.c
--- v2.6.33/linux/kernel/sysctl_binary.c	2010-02-25 09:01:36.000000000 +0200
+++ linux/kernel/sysctl_binary.c	2010-02-25 10:52:49.000000000 +0200
@@ -247,6 +247,7 @@ static const struct bin_table bin_net_ip
 	{ CTL_INT,	NET_IPV4_CONF_ARP_IGNORE,		"arp_ignore" },
 	{ CTL_INT,	NET_IPV4_CONF_ARP_ACCEPT,		"arp_accept" },
 	{ CTL_INT,	NET_IPV4_CONF_ARP_NOTIFY,		"arp_notify" },
+	{ CTL_INT,	NET_IPV4_CONF_FORWARD_SHARED,		"forward_shared" },
 
 	{ CTL_INT,	NET_IPV4_CONF_NOXFRM,			"disable_xfrm" },
 	{ CTL_INT,	NET_IPV4_CONF_NOPOLICY,			"disable_policy" },
diff -urp v2.6.33/linux/net/ipv4/devinet.c linux/net/ipv4/devinet.c
--- v2.6.33/linux/net/ipv4/devinet.c	2010-02-25 09:01:36.000000000 +0200
+++ linux/net/ipv4/devinet.c	2010-02-25 10:50:30.000000000 +0200
@@ -1413,6 +1413,7 @@ static struct devinet_sysctl_table {
 		DEVINET_SYSCTL_RW_ENTRY(ARP_IGNORE, "arp_ignore"),
 		DEVINET_SYSCTL_RW_ENTRY(ARP_ACCEPT, "arp_accept"),
 		DEVINET_SYSCTL_RW_ENTRY(ARP_NOTIFY, "arp_notify"),
+		DEVINET_SYSCTL_RW_ENTRY(FORWARD_SHARED, "forward_shared"),
 
 		DEVINET_SYSCTL_FLUSHING_ENTRY(NOXFRM, "disable_xfrm"),
 		DEVINET_SYSCTL_FLUSHING_ENTRY(NOPOLICY, "disable_policy"),
diff -urp v2.6.33/linux/net/ipv4/fib_frontend.c linux/net/ipv4/fib_frontend.c
--- v2.6.33/linux/net/ipv4/fib_frontend.c	2010-02-25 09:01:36.000000000 +0200
+++ linux/net/ipv4/fib_frontend.c	2010-02-25 10:54:13.000000000 +0200
@@ -230,7 +230,7 @@ unsigned int inet_dev_addr_type(struct n
 
 int fib_validate_source(__be32 src, __be32 dst, u8 tos, int oif,
 			struct net_device *dev, __be32 *spec_dst,
-			u32 *itag, u32 mark)
+			u32 *itag, u32 mark, int our)
 {
 	struct in_device *in_dev;
 	struct flowi fl = { .nl_u = { .ip4_u =
@@ -243,6 +243,7 @@ int fib_validate_source(__be32 src, __be
 	struct fib_result res;
 	int no_addr, rpf, accept_local;
 	int ret;
+	int fwdsh = 0;
 	struct net *net;
 
 	no_addr = rpf = accept_local = 0;
@@ -254,6 +255,7 @@ int fib_validate_source(__be32 src, __be
 		accept_local = IN_DEV_ACCEPT_LOCAL(in_dev);
 		if (mark && !IN_DEV_SRC_VMARK(in_dev))
 			fl.mark = 0;
+		fwdsh = IN_DEV_FORWARD_SHARED(in_dev);
 	}
 	rcu_read_unlock();
 
@@ -263,6 +265,13 @@ int fib_validate_source(__be32 src, __be
 	net = dev_net(dev);
 	if (fib_lookup(net, &fl, &res))
 		goto last_resort;
+	if (fwdsh) {
+		fwdsh = (res.type == RTN_LOCAL && !our);
+		if (fwdsh) {
+			rpf = 0;
+			accept_local = 1;
+		}
+	}
 	if (res.type != RTN_UNICAST) {
 		if (res.type != RTN_LOCAL || !accept_local)
 			goto e_inval_res;
@@ -285,6 +294,8 @@ int fib_validate_source(__be32 src, __be
 	if (rpf == 1)
 		goto e_inval;
 	fl.oif = dev->ifindex;
+	if (fwdsh)
+		fl.iif = net->loopback_dev->ifindex;
 
 	ret = 0;
 	if (fib_lookup(net, &fl, &res) == 0) {
diff -urp v2.6.33/linux/net/ipv4/route.c linux/net/ipv4/route.c
--- v2.6.33/linux/net/ipv4/route.c	2010-02-25 09:01:36.000000000 +0200
+++ linux/net/ipv4/route.c	2010-02-25 10:50:30.000000000 +0200
@@ -1857,7 +1857,7 @@ static int ip_route_input_mc(struct sk_b
 			goto e_inval;
 		spec_dst = inet_select_addr(dev, 0, RT_SCOPE_LINK);
 	} else if (fib_validate_source(saddr, 0, tos, 0,
-					dev, &spec_dst, &itag, 0) < 0)
+					dev, &spec_dst, &itag, 0, our) < 0)
 		goto e_inval;
 
 	rth = dst_alloc(&ipv4_dst_ops);
@@ -1970,7 +1970,7 @@ static int __mkroute_input(struct sk_buf
 
 
 	err = fib_validate_source(saddr, daddr, tos, FIB_RES_OIF(*res),
-				  in_dev->dev, &spec_dst, &itag, skb->mark);
+				  in_dev->dev, &spec_dst, &itag, skb->mark, 0);
 	if (err < 0) {
 		ip_handle_martian_source(in_dev->dev, in_dev, skb, daddr,
 					 saddr);
@@ -2144,7 +2144,7 @@ static int ip_route_input_slow(struct sk
 		int result;
 		result = fib_validate_source(saddr, daddr, tos,
 					     net->loopback_dev->ifindex,
-					     dev, &spec_dst, &itag, skb->mark);
+					     dev, &spec_dst, &itag, skb->mark, 1);
 		if (result < 0)
 			goto martian_source;
 		if (result)
@@ -2173,7 +2173,7 @@ brd_input:
 		spec_dst = inet_select_addr(dev, 0, RT_SCOPE_LINK);
 	else {
 		err = fib_validate_source(saddr, 0, tos, 0, dev, &spec_dst,
-					  &itag, skb->mark);
+					  &itag, skb->mark, 1);
 		if (err < 0)
 			goto martian_source;
 		if (err)