diff -urp v2.6.33/linux/Documentation/networking/ip-sysctl.txt linux/Documentation/networking/ip-sysctl.txt
--- v2.6.33/linux/Documentation/networking/ip-sysctl.txt	2010-02-25 09:01:26.000000000 +0200
+++ linux/Documentation/networking/ip-sysctl.txt	2010-02-25 11:56:12.000000000 +0200
@@ -669,6 +669,13 @@ accept_redirects - BOOLEAN
 forwarding - BOOLEAN
 	Enable IP forwarding on this interface.
 
+loop - BOOLEAN
+	By default (loop=0) the traffic between local IP addresses
+	is routed via interface "lo". Setting this flag for two
+	interfaces allows traffic between their IP addresses to
+	be looped externally. This is useful for setups where the
+	interfaces are attached to same broadcast medium.
+
 mc_forwarding - BOOLEAN
 	Do multicast routing. The kernel needs to be compiled with CONFIG_MROUTE
 	and a multicast routing daemon is required.
diff -urp v2.6.33/linux/include/linux/inetdevice.h linux/include/linux/inetdevice.h
--- v2.6.33/linux/include/linux/inetdevice.h	2010-02-25 09:01:36.000000000 +0200
+++ linux/include/linux/inetdevice.h	2010-02-25 11:56:12.000000000 +0200
@@ -106,6 +106,7 @@ static inline void ipv4_devconf_setall(s
 	  IN_DEV_ORCONF((in_dev), ACCEPT_REDIRECTS)))
 
 #define IN_DEV_ARPFILTER(in_dev)	IN_DEV_ORCONF((in_dev), ARPFILTER)
+#define IN_DEV_LOOP(in_dev)		IN_DEV_CONF_GET(in_dev, LOOP)
 #define IN_DEV_ARP_ANNOUNCE(in_dev)	IN_DEV_MAXCONF((in_dev), ARP_ANNOUNCE)
 #define IN_DEV_ARP_IGNORE(in_dev)	IN_DEV_MAXCONF((in_dev), ARP_IGNORE)
 #define IN_DEV_ARP_NOTIFY(in_dev)	IN_DEV_MAXCONF((in_dev), ARP_NOTIFY)
diff -urp v2.6.33/linux/include/linux/sysctl.h linux/include/linux/sysctl.h
--- v2.6.33/linux/include/linux/sysctl.h	2010-02-25 09:01:36.000000000 +0200
+++ linux/include/linux/sysctl.h	2010-02-25 11:56:31.000000000 +0200
@@ -483,6 +483,7 @@ enum
 	NET_IPV4_CONF_ARP_NOTIFY=22,
 	NET_IPV4_CONF_ACCEPT_LOCAL=23,
 	NET_IPV4_CONF_SRC_VMARK=24,
+	NET_IPV4_CONF_LOOP=25,
 	__NET_IPV4_CONF_MAX
 };
 
diff -urp v2.6.33/linux/kernel/sysctl_binary.c linux/kernel/sysctl_binary.c
--- v2.6.33/linux/kernel/sysctl_binary.c	2010-02-25 09:01:36.000000000 +0200
+++ linux/kernel/sysctl_binary.c	2010-02-25 11:57:21.000000000 +0200
@@ -247,6 +247,7 @@ static const struct bin_table bin_net_ip
 	{ CTL_INT,	NET_IPV4_CONF_ARP_IGNORE,		"arp_ignore" },
 	{ CTL_INT,	NET_IPV4_CONF_ARP_ACCEPT,		"arp_accept" },
 	{ CTL_INT,	NET_IPV4_CONF_ARP_NOTIFY,		"arp_notify" },
+	{ CTL_INT,	NET_IPV4_CONF_LOOP,			"loop" },
 
 	{ CTL_INT,	NET_IPV4_CONF_NOXFRM,			"disable_xfrm" },
 	{ CTL_INT,	NET_IPV4_CONF_NOPOLICY,			"disable_policy" },
diff -urp v2.6.33/linux/net/ipv4/devinet.c linux/net/ipv4/devinet.c
--- v2.6.33/linux/net/ipv4/devinet.c	2010-02-25 09:01:36.000000000 +0200
+++ linux/net/ipv4/devinet.c	2010-02-25 11:56:12.000000000 +0200
@@ -1413,6 +1413,7 @@ static struct devinet_sysctl_table {
 		DEVINET_SYSCTL_RW_ENTRY(ARP_IGNORE, "arp_ignore"),
 		DEVINET_SYSCTL_RW_ENTRY(ARP_ACCEPT, "arp_accept"),
 		DEVINET_SYSCTL_RW_ENTRY(ARP_NOTIFY, "arp_notify"),
+		DEVINET_SYSCTL_RW_ENTRY(LOOP, "loop"),
 
 		DEVINET_SYSCTL_FLUSHING_ENTRY(NOXFRM, "disable_xfrm"),
 		DEVINET_SYSCTL_FLUSHING_ENTRY(NOPOLICY, "disable_policy"),
diff -urp v2.6.33/linux/net/ipv4/fib_frontend.c linux/net/ipv4/fib_frontend.c
--- v2.6.33/linux/net/ipv4/fib_frontend.c	2010-02-25 09:01:36.000000000 +0200
+++ linux/net/ipv4/fib_frontend.c	2010-02-25 11:58:49.000000000 +0200
@@ -242,6 +242,7 @@ int fib_validate_source(__be32 src, __be
 
 	struct fib_result res;
 	int no_addr, rpf, accept_local;
+	int loop = 0;
 	int ret;
 	struct net *net;
 
@@ -254,6 +255,7 @@ int fib_validate_source(__be32 src, __be
 		accept_local = IN_DEV_ACCEPT_LOCAL(in_dev);
 		if (mark && !IN_DEV_SRC_VMARK(in_dev))
 			fl.mark = 0;
+		loop = IN_DEV_LOOP(in_dev);
 	}
 	rcu_read_unlock();
 
@@ -263,6 +265,11 @@ int fib_validate_source(__be32 src, __be
 	net = dev_net(dev);
 	if (fib_lookup(net, &fl, &res))
 		goto last_resort;
+	if (loop && res.type == RTN_LOCAL) {
+		*spec_dst = FIB_RES_PREFSRC(res);
+		fib_res_put(&res);
+		return 0;
+	}
 	if (res.type != RTN_UNICAST) {
 		if (res.type != RTN_LOCAL || !accept_local)
 			goto e_inval_res;
diff -urp v2.6.33/linux/net/ipv4/route.c linux/net/ipv4/route.c
--- v2.6.33/linux/net/ipv4/route.c	2010-02-25 09:01:36.000000000 +0200
+++ linux/net/ipv4/route.c	2010-02-25 11:56:12.000000000 +0200
@@ -2567,6 +2567,11 @@ static int ip_route_output_slow(struct n
 			dev_put(dev_out);
 			goto out;	/* Wrong error code */
 		}
+		err = -ENETDOWN;
+		if (!(dev_out->flags&IFF_UP)) {
+			dev_put(dev_out);
+			goto out;
+		}
 
 		if (ipv4_is_local_multicast(oldflp->fl4_dst) ||
 		    oldflp->fl4_dst == htonl(0xFFFFFFFF)) {
@@ -2634,10 +2639,41 @@ static int ip_route_output_slow(struct n
 	free_res = 1;
 
 	if (res.type == RTN_LOCAL) {
-		if (!fl.fl4_src)
-			fl.fl4_src = fl.fl4_dst;
+		struct in_device *in_dev;
+		__be32 src;
+
 		if (dev_out)
 			dev_put(dev_out);
+		dev_out = FIB_RES_DEV(res);
+		in_dev = in_dev_get(dev_out);
+		src = fl.fl4_src? : FIB_RES_PREFSRC(res);
+		if (in_dev && IN_DEV_LOOP(in_dev) && src) {
+			struct net_device *dev_src;
+
+			in_dev_put(in_dev);
+			in_dev = NULL;
+			dev_src = ip_dev_find(net, src);
+			if (dev_src && dev_src != dev_out &&
+			    (in_dev = in_dev_get(dev_src)) &&
+			    IN_DEV_LOOP(in_dev)) {
+				in_dev_put(in_dev);
+				dev_out = dev_src;
+				fl.fl4_src = src;
+				fl.oif = dev_out->ifindex;
+				res.type = RTN_UNICAST;
+				if (res.fi) {
+					fib_info_put(res.fi);
+					res.fi = NULL;
+				}
+				goto make_route;
+			}
+			if (dev_src)
+				dev_put(dev_src);
+		}
+		if (in_dev)
+			in_dev_put(in_dev);
+		if (!fl.fl4_src)
+			fl.fl4_src = fl.fl4_dst;
 		dev_out = net->loopback_dev;
 		dev_hold(dev_out);
 		fl.oif = dev_out->ifindex;